Global CurrentDirectory.s
CurrentDirectory = Space(#MAX_PATH)

Global hListIconGadget.l 

#LVM_SETEXTENDEDLISTVIEWSTYLE = #LVM_FIRST + 54
#LVM_GETEXTENDEDLISTVIEWSTYLE = #LVM_FIRST + 55
#ListIconTextColor1 = $5F0000
#ListIconBackgroundColor1 = $D0FFFF
#ListIconTextColor2 = $D0FFFF
#ListIconBackgroundColor2 = $5F0000

#NM_CUSTOMDRAW = #NM_FIRST - 12

#CDDS_ITEM = $10000 
#CDDS_PREPAINT = $1 
#CDDS_ITEMPREPAINT = #CDDS_ITEM | #CDDS_PREPAINT 
#CDRF_DODEFAULT = $0 
#CDRF_NOTIFYITEMDRAW = $20 

#PB_Shortcut_CTRL_F = $6

Global Buffer1.l, Buffer2.l, lvi.LV_ITEM, updown.l, lastcol.l

Buffer1 = AllocateMemory(128)
Buffer2 = AllocateMemory(128)

Enumeration
  #Window_Main
  #Gadget_Image
  #Gadget_ListIcon
  #Menu_Item_Find
  #Menu_Item_Exit
  #PopupMenu
EndEnumeration

Procedure CompareFunc(item1, item2, lParamSort)
  result = 0
  lvi\iSubItem = lParamSort
  lvi\pszText = Buffer1
  lvi\cchTextMax = 128
  lvi\mask = #LVIF_TEXT
  SendMessage_(hListIconGadget, #LVM_GETITEMTEXT, item1, @lvi)
  lvi\pszText = Buffer2
  SendMessage_(hListIconGadget, #LVM_GETITEMTEXT, item2, @lvi)
  Seeker1 = Buffer1
  Seeker2 = Buffer2
  done = #FALSE
  Repeat
    char1 = Asc(UCase(Chr(PeekB(Seeker1))))
    char2 = Asc(UCase(Chr(PeekB(Seeker2))))
    result = (char1 - char2) * updown
    If result <> 0 Or (Seeker1 - Buffer1) > 127
        done = #TRUE
    EndIf
    Seeker1 + 1
    Seeker2 + 1
  Until Done
  ProcedureReturn result
EndProcedure

Procedure UpdatelParam()
  ItemCount = SendMessage_(hListIconGadget, #LVM_GETITEMCOUNT, 0, 0)
  lvi\mask = #LVIF_PARAM
  lvi\iItem = 0
  While ItemCount > 0
    lvi\lParam = lvi\iItem
    For SubItem = 0 To 3
      lvi\iSubItem = SubItem 
      SendMessage_(hListIconGadget, #LVM_SETITEM, 0, @lvi)
    Next SubItem
    lvi\iItem = lvi\iItem + 1
    ItemCount = ItemCount - 1
  Wend
EndProcedure

Procedure ColumnClickCallback(Handle, Message, wParam, lParam)
  Result = #PB_ProcessPureBasicEvents
  Select Message
    Case #WM_NOTIFY
      *msg.NMHDR = lParam
      If *msg\hwndFrom = hListIconGadget And *msg\code = #LVN_COLUMNCLICK
          *pnmv.NM_LISTVIEW = lParam
          If lastcol <> *pnmv\iSubItem
              updown = 1
          EndIf
          SendMessage_(hListIconGadget, #LVM_SORTITEMS, *pnmv\iSubItem, @CompareFunc())
          UpdatelParam()
          UpdateWindow_(hListIconGadget)
          lastcol = *pnmv\iSubItem
          updown = -updown
      EndIf
      *LVCDHeader.NMLVCUSTOMDRAW = lParam
      If *LVCDHeader\nmcd\hdr\hWndFrom = hListIconGadget And *LVCDHeader\nmcd\hdr\code = #NM_CUSTOMDRAW
          Select *LVCDHeader\nmcd\dwDrawStage
            Case #CDDS_PREPAINT
              ProcedureReturn #CDRF_NOTIFYITEMDRAW
            Case #CDDS_ITEMPREPAINT
              Row.l = *LVCDHeader\nmcd\dwItemSpec
              If (Row / 2) * 2 = Row
                  *LVCDHeader\clrText = #ListIconTextColor1
                  *LVCDHeader\clrTextBk = #ListIconBackgroundColor1
                Else
                  *LVCDHeader\clrText = #ListIconTextColor2
                  *LVCDHeader\clrTextBk = #ListIconBackgroundColor2
              EndIf
              ProcedureReturn #CDRF_DODEFAULT
          EndSelect
      EndIf
    Case #WM_LBUTTONDOWN
      ReleaseCapture_()
      SendMessage_(WindowID(), #WM_NCLBUTTONDOWN, #HTCAPTION, #NULL)
    Case #WM_RBUTTONDOWN
      DisplayPopupMenu(#PopupMenu, WindowID())
    Case #WM_PAINT
      HideWindow(#Window_Main, 1)
      HideWindow(#Window_Main, 0)
    Case #WM_SIZE
      If Handle = WindowID() And IsIconic_(Handle) = 0
          WindowWidth = lParam & $ffff
          WindowHeight = lParam >> 16
          ResizeGadget(#Gadget_ListIcon, 25, 25, WindowWidth - 50, WindowHeight - 50)
          Result = 1
      EndIf
  EndSelect
  ProcedureReturn Result
EndProcedure


  FileName.s = "Constants.out"
  StringToFind.s = ""
  FindIndex.l = -1
  WindowXSize.l = 470
  WindowYSize.l = 360
  GetCurrentDirectory_(255, @CurrentDirectory)
  CurrentDirectory + "\"
  FileName.s
  GetCursorPos_(CursorPosition.POINT)
  Quit.l = #FALSE

  MessageBeep_(#MB_ICONHAND)

  If OpenWindow(#Window_Main, CursorPosition\x - WindowXSize / 2, CursorPosition\y - WindowYSize / 2, WindowXSize, WindowYSize - 20, #PB_Window_Invisible, "YABL")
      AddKeyboardShortcut(#Window_Main, #PB_Shortcut_Escape, #PB_Shortcut_Escape)
      AddKeyboardShortcut(#Window_Main, #PB_Shortcut_F3, #PB_Shortcut_F3)
      AddKeyboardShortcut(#Window_Main, #PB_Shortcut_F | #PB_Shortcut_Control, #PB_Shortcut_CTRL_F)
Debug #PB_Shortcut_CTRL_F
      GetWindowRect_(WindowID(), MyRect.RECT)
      ImageID = CreateImage(0, WindowXSize, WindowYSize)
      StartDrawing(ImageOutput())
        For i = 0 To 31
          Box(i, i, WindowXSize - 2 * i, WindowYSize - 2 * i, RGB(0, 0, 255 - 8 * i))
        Next
        DrawingMode(4)
        Box(0, 0, WindowXSize, WindowYSize, $C0FFFF)
      StopDrawing()
      If CreateGadgetList(WindowID())
          SetGadgetFont(#PB_Default, LoadFont(0, "Verdana", 7, #PB_Font_HighQuality))
          ImageGadget(#Gadget_Image, 0, 0, WindowXSize, WindowYSize, ImageID)
          hListIconGadget = ListIconGadget(#Gadget_ListIcon, 25, 25, WindowXSize - 50, WindowYSize - 50, "Name", 240, #PB_ListIcon_GridLines | #PB_ListIcon_FullRowSelect | #PB_ListIcon_HeaderDragDrop | #PB_ListIcon_AlwaysShowSelection)
          AddGadgetColumn(#Gadget_ListIcon, 1, "Value (10)", 80)
          AddGadgetColumn(#Gadget_ListIcon, 2, "Hex Value", 80)
      EndIf
      
      updown = 1
      lastcol = 0
      UpdatelParam()
      SetWindowCallback(@ColumnClickCallback())
      
      SetWindowLong_(WindowID(), #GWL_STYLE, #WS_DLGFRAME | #WS_CLIPCHILDREN | #WS_CLIPSIBLINGS)
      SetWindowPos_(WindowID(), 0, 0, 0, 0, 0, #SWP_NOSIZE | #SWP_NOMOVE | #SWP_FRAMECHANGED)
      While WindowEvent()
      Wend
      HideWindow(0,0)

      Column.LV_COLUMN
      Column\mask = #LVCF_FMT
      Column\fmt = #LVCFMT_RIGHT
      SendMessage_(hListIconGadget, #LVM_SETCOLUMN, 1, @Column)
      SendMessage_(hListIconGadget, #LVM_SETCOLUMN, 2, @Column)

      If ReadFile(0, FileName)
          Repeat
            a$ = ReadString()
            a$ = a$ + Chr(10) + ReadString()
            a$ = a$ + Chr(10) + ReadString()
            AddGadgetItem(#Gadget_ListIcon, -1, a$)
            While WindowEvent()
            Wend
          Until Eof(0)
          CloseFile(0)
      EndIf
      
      ItemsCount = CountGadgetItems(#Gadget_ListIcon)

      MessageBeep_(#MB_ICONASTERISK)
      
      If CreatePopupMenu(#PopupMenu)
          MenuItem(#Menu_Item_Find, "Find")
          MenuBar()
          MenuItem(#Menu_Item_Exit, "Exit")
      EndIf

      Repeat
        Select WaitWindowEvent()
          Case #PB_Event_CloseWindow
            Quit = #TRUE
          Case #PB_Event_Menu
            Select EventMenuID()
              Case #PB_Shortcut_Escape
                Quit = #TRUE
              Case #PB_Shortcut_CTRL_F
                Debug "#PB_Shortcut_CTRL_F"
                Goto FindFirst
              Case #PB_Shortcut_F3
                Goto FindNext
              Case #Menu_Item_Find
FindFirst:
                StringToFind = InputRequester("User input", "Enter string To find", StringToFind)
FindNext:
                If StringToFind = ""
                    Goto FindFirst
                EndIf
                CurrentIndex = GetGadgetState(#Gadget_ListIcon)
                FindIndex + 1
                i = FindIndex
                Repeat
                  For j = 0 To 2
                    If FindString(GetGadgetItemText(#Gadget_ListIcon, i, j), StringToFind, 1)
                        FindIndex = i
                        SetGadgetState(#Gadget_ListIcon, FindIndex)
                        SetGadgetItemState(#Gadget_ListIcon, FindIndex, #PB_ListIcon_Selected | #PB_ListIcon_Checked)
                        SendMessage_(hListIconGadget, #LVM_ENSUREVISIBLE, FindIndex, #FALSE)
                        Break 2
                    EndIf
                  Next
                  i + 1
                  If i => ItemsCount
                      i = 0
                  EndIf
                Until i = FindIndex
              Case #Menu_Item_Exit
                Quit = #TRUE
            EndSelect
          Case #PB_Event_Gadget
        EndSelect
      Until Quit
  EndIf
  TerminateProcess_(GetCurrentProcess_(), 0)
End
; ExecutableFormat=Windows
; CursorPosition=130
; FirstLine=105
; Executable=C:\RECUP\PureBasic\Design\PB Constants sniffer\PB Constants display.exe
; EOF